#
# Copyright (C) 2007 - 2008 M <optimizationkit@gmail.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

import os, commands, time
from xml.etree.ElementTree import Element, SubElement, ElementTree, parse

def read_pref_conf_file(pref_conf_file):
	pref_conf = []
	config_file = ElementTree(file = pref_conf_file)
	iter = config_file.getiterator()
	for element in iter:
		if element.tag == "app":
			for o, v in element.items():
				if o == "bin":
					pref_conf.append(v)

	return pref_conf

def start_prefetch(config):
	for app in config:
		print "Prefetching app = %s\n" % app
		os.system("cat " + app + " > /dev/null")

def ret_disc_usage(disc):
	du = commands.getoutput("cat /proc/diskstats | grep " + disc)
	du = du.split("\n")[0]
	du = du.split(" ")[-3]
	return int(du)

def prepare_prefetch(pref_conf):
	stop = 2

	root_fs = commands.getoutput("df / | grep /dev")
	root_fs = root_fs.split(" ")[0]
	root_fs = root_fs.split("/")[-1]
	root_fs = root_fs.rstrip("123456789")

	usr_fs = commands.getoutput("df /usr | grep /dev")
	usr_fs = usr_fs.split(" ")[0]
	usr_fs = usr_fs.split("/")[-1]
	usr_fs = usr_fs.rstrip("123456789")

	while (stop):
		root_fs_du = ret_disc_usage(root_fs)
		usr_fs_du = ret_disc_usage(usr_fs)
		if (root_fs_du < 10) and (usr_fs_du < 10):
			stop -= 1
			time.sleep(1)

	start_prefetch(pref_conf)

def prefetch(pref_conf_file):
	pref_conf = read_pref_conf_file(pref_conf_file)
	prepare_prefetch(pref_conf)
