#
# Copyright (C) 2007 - 2008 M <optimizationkit@gmail.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# OptimizationKit - mode 3

from time import sleep
from ok_cg import setup_cgroups, create_groups_from_config, add_tasks_to_cgroup

def start_mode_3(configuration):
	setup_cgroups(configuration[0]["cpu_exclusive"], configuration[0]["mem_exclusive"], configuration[0]["features"], configuration[0]["cgroup_mount_dir"])
	create_groups_from_config(configuration[1], configuration[0]["cgroup_mount_dir"])

	while True:
		for i in configuration[1]:
			add_tasks_to_cgroup(i[0], i[-3], "-U", configuration[0]["cgroup_mount_dir"])
		sleep(configuration[0]["lt"])
